from parsers.parser import Parser
#from parser import Parser
import time
import os
import datetime
import xmltodict

__author__ = 'Markus Schatten'


class Config(Parser):
    url = 'config'
    character = ''

    def get_config_log_data(self, path, user_character):
        """
        Method that does all the heavy lifting in this class
        It checks if config file exists, compares timestamps.txt and
        returns all the new config log data as JSON object
        """
        if self.check_log_file_exists(path):
            last_timestamp =  self.get_timestamp_db( 'config' ) # 
            last_modification = datetime.datetime.fromtimestamp( os.path.getmtime( path ) )
            last_modification = last_modification.replace( second=0 )
            UTC_OFFSET_TIMEDELTA = datetime.datetime.utcnow() - datetime.datetime.now()
            result_utc_datetime = last_modification + UTC_OFFSET_TIMEDELTA
            result_utc_datetime = result_utc_datetime.replace( second=0, microsecond=0 )
            if last_timestamp < result_utc_datetime:
                self.character = user_character
                conf = open( path ).read()
                xml = xmltodict.parse( conf )
                self.create_config_log_request( xml )
                return True


    def create_config_log_request(self, config):
        """
        Method that creates config log request
        :param config to be saved
        """
        last_timestamp = self.get_timestamp_db('config')
        request = {}

        request["config"] = config
        request["character"] = self.character

        self.send_request(self.url, request,'config')

